$extend(obj, ext, override, deep)
---------------------------------
Extend an object with another object


**Parameters**

**obj**:  *Object*,  object to be extended

**ext**:  *Object*,  extension object

**override**:  *bool*,  Overwrite existing properties in obj

**deep**:  *bool*,  Doing an deep extend (perform extend on every object property)

**Returns**

*Object*,  reference to obj

$define(object, prototype, preserve)
------------------------------------
Define properties of an Object, Which usually used to extend prototype
of an object, as it will set properties as non-enumerable, and will
turn setValue(value) and getValue() functions to setter and getters.
Note: You should only use $define or Object.defineProperty on prototype,
or on a class' itself (to define static methods), instead of on instances
which could lead to severe performance issue.


**Parameters**

**object**:  *Object*,  target object

**prototype**:  *Object*,  extension object

**preserve**:  *bool*,  preserve existing property

**Returns**

*Object*,  reference to object

$declare(fn, prototype)
-----------------------
Declare a Class.


**Parameters**

**fn**:  *Function*,  constructor of the Class

**prototype**:  *Object*,  prototype of Class

**Returns**

*Function*,  reference to constructor

$inherit(fn, parent, prototype)
-------------------------------
Inherit another Class to current Class


**Parameters**

**fn**:  *Function*,  constructor of the Class

**parent**:  *Function*,  parent Class

**prototype**:  *Object*,  prototype of Class

**Returns**

*Function*,  reference to constructor

$defenum(fn, values)
--------------------
Adding enumerations to a Class (both static and prototype).


**Parameters**

**fn**:  *Function*,  constructor of the Class

**values**:  *Object*,  object holding all enumerates want to define

**Returns**

*Function*,  reference to constructor

$error()
--------
Making an Error instance with given format and parameters.
Note: this is a helper function works like util.format(),
apart from it returns an Error object instead of string.


**Returns**

*Error*,  generated Error instance

$valueCopy(obj)
---------------
Generate a deep copy of an Object with its primitive typed
fields (exclude functions).


**Parameters**

**obj**:  *mixed*,  source object

**Returns**

*mixed*,  cloned object

$clone(org, deep)
-----------------
Generates a copy of an Object.


**Parameters**

**org**:  *Mixed*,  source object

**deep**:  *bool*,  perform a deep clone

**Returns**

*Mixed*,  cloned object

$default(val, def)
------------------
Return default value of an undefined variable.


**Parameters**

**val**:  *Mixed*,  value

**def**:  *Mixed*,  default value

$wrap(obj, Type)
----------------
Wrap an object with given Class.
Note: it will call Class.__wrap method to do custom wrapping.


**Parameters**

**obj**:  *Object*,  object to be wrapped

**Type**:  *Function*,  wrapping Class

**Returns**

*Object*,  wrapped object

$strip(object)
--------------
Removing prototype chain from a given object.


**Parameters**

**object**:  *Object*,  object to be stripped

**Returns**

*Object*,  object stripped

$typeof(obj)
------------
Use Object.prototype.toString to determine an element's type
This method provide more stricter strategy on type detection,
can be worked with typeof.
but with better precision.


**Parameters**

**obj**:  *Mixed*,  Variable

**Returns**

*String*,  type of the variable, like typeof,

repeat(times)
-------------
Repeat current string for given times.


**Parameters**

**times**:  *int*,  Times to repeat

**Returns**

*string*,  result

paddingLeft(ch, length)
-----------------------
Padding this to given length with specified char from left.


**Parameters**

**ch**:  *char*,  padding char

**length**:  *int*,  desired length

**Returns**

*string*,  result

paddingRight(ch, length)
------------------------
Padding this to given length with specified char from right.


**Parameters**

**ch**:  *char*,  padding char

**length**:  *int*,  desired length

**Returns**

*string*,  result

startsWith(str, pos)
--------------------
Tests if this string starts with the given one.
to 0


**Parameters**

**str**:  *string*,  string to test with

**pos**:  *number*,  optional, position to start compare, defaults

**Returns**

*bool*,  result

endsWith(str, len)
------------------
Tests if this string ends with the given one.
defaults to actual length


**Parameters**

**str**:  *string*,  string to test with

**len**:  *number*,  optional, pretend this string is of given length,

**Returns**

*bool*,  result

toTitleCase()
-------------
Return a string in it's title form.
Note: if a word containing upper case, nothing
will be done.


**Returns**

*string*,  string in title case

clamp(lb, ub)
-------------
Clamp a this to given range [lb, ub]


**Parameters**

**lb**:  *number*,  lower bound

**ub**:  *number*,  upper bound

**Returns**

*number*,  result

floor()
-------
Shortcut to Math.floor(this)


**Returns**

*number*,  Math.floor(this)

ceil()
------
Shortcut to Math.ceil(this)


**Returns**

*number*,  Math.ceil(this)

round(decimals)
---------------
Shortcut to Math.round(this) with additional parameters


**Parameters**

**decimals**:  *number*,  number of decimal digits to round up to

**Returns**

*number*,  rounded number

toGroup(decimals, separator)
----------------------------
Get the thousands separated number


**Parameters**

**decimals**:  *number*,  number of decimal digits to remain

**separator**:  *string*,  separator

**Returns**

*string*,  separated number

min()
-----
get minimum value in this array


**Returns**

*Mixed*,  minimal value

max()
-----
get maximum value in this array


**Returns**

*Mixed*,  maximum value

add(val)
--------
Push a value iif it's not in this array, and return value's index.


**Parameters**

**val**:  *Mixed*,  new value

**Returns**

*int*,  index of the value

remove(val)
-----------
Find a value in the array and remove it.


**Parameters**

**val**:  *Mixed*,  value to remove

rotate(n)
---------
Rotate this array (n->0, n+1->1, ...)


**Parameters**

**n**:  *int*,  the offset

**Returns**

*Array*,  this

back()
------
get last element in this array
Note: It's not a reference when returning a non-object!


**Returns**

*Mixed*,  last element

front()
-------
get first element in this array
Note: It's not a reference when returning a non-object!


**Returns**

*Mixed*,  first element

flatten(deep)
-------------
Flattern a array with sub arrays.


**Parameters**

**deep**:  *bool*,  if continue to flatten sub arrays

**Returns**

*Array*,  flattened array.

unique()
--------
Return unique elements in the array


shuffle()
---------
shuffle elements in the array in-place


isEmpty(obj)
------------
Determine if an object is empty


**Parameters**

**obj**:  *Object*,  object to test

**Returns**

*bool*,  object is empty

values(obj)
-----------
Get values of an object, like Object.keys().


**Parameters**

**obj**:  *Object*,  object to extract

**Returns**

*Array*,  values in the object

isObject(obj)
-------------
Vague but fast isObject test
Note: new String(), function, array, etc will return true


**Parameters**

**obj**:  *Mixed*,  object to test

**Returns**

*bool*,  true if obj is an object and not null

isObjectStrict(obj)
-------------------
Strict isObject test, only pure Object will return true
Note: only {} will return true


**Parameters**

**obj**:  *Mixed*,  object to test

**Returns**

*bool*,  true if obj is strictly an object

project(object, projection, deep, keep)
---------------------------------------
project $object with projectiong, same behaviour with mongodb projection


**Parameters**

**object**:  *Object*,  target object

**projection**:  *Object*,  An object mapping fields to values

**deep**:  *Boolean*,  if true, go deep for sub objects

**keep**:  *Boolean*,  if true, keep undefined field of this

**Returns**

*Object*,  projected object

isFunction(obj)
---------------
Test if an object is a function


**Parameters**

**obj**:  *Mixed*,  object to test

**Returns**

*bool*,  true if so

cast(obj)
---------
Cast a value to Date


**Parameters**

**obj**:  *Mixed*,  object to cast

**Returns**

*Date*,  casted value

isDate(object)
--------------
Determine if an object is a Date


**Parameters**

**object**:  *Object*,  to test

**Returns**

*bool*,  true iif it's a date.

cast(obj)
---------
Cast a value to bool


**Parameters**

**obj**:  *Object*,  object to cast

**Returns**

*bool*,  casted value

escape(str)
-----------
Escape a string to work within a regular expression


**Parameters**

**str**:  *string*,  string to escape

**Returns**

*strign*,  escaped string

